<?php

defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent( 'onSearch', 'plgSearchResourcesearchbot' );
$mainframe->registerEvent( 'onSearchAreas', 'plgSearchResourcesearchbotAreas' );

//JPlugin::loadLanguage( 'plg_search_categories' );
jimport('joomla.utilities.date');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
/**
 * @return array An array of search areas
 */
function &plgSearchResourcesearchbotAreas()
{

	static $areas = array();

	$plugin =& JPluginHelper::getPlugin('search', 'resourcesearchbot');
	$pluginParams = new JParameter( $plugin->params );

	if( !count($areas) ) {
		JModel::addIncludePath(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'models');

		$record_model = JModel::getInstance('record', 'ResModel');

		$types = $record_model->getTypes();
		$param_types = $pluginParams->get('search_types');

		if( !is_array( $param_types ) ) {
			$param_types = array( $param_types );
		}
		foreach( $types as $type ) {
			if(  in_array( $type->value, $param_types ) ) {
				$areas[ $type->value.'-' ] = $type->text;
			}
		}
	}
	return $areas;
}

/**
 * Categories Search method
 *
 * The sql must return the following fields that are
 * used in a common display routine: href, title, section, created, text,
 * browsernav
 * @param string Target search string
 * @param string mathcing option, exact|any|all
 * @param string ordering option, newest|oldest|popular|alpha|category
 * @param mixed An array if restricted to areas, null if search all
 */
function plgSearchResourcesearchbot( $text, $phrase='', $ordering='', $areas=null )
{

	global $Itemid;
	$db    =& JFactory::getDBO();
	$user  =& JFactory::getUser();

	jimport ('joomla.filesystem.file');
	jimport ('joomla.filesystem.folder');
	
	require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
	ResControllerConfig::initialyze();
			
	JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');
	//JModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'models');

	$article_model = JModel::getInstance('article', 'ResModel');
	$list_model    = JModel::getInstance('list',    'ResModel');

	//require_once( JPATH_SITE.DS.'components'.DS.'com_resource'.DS.'route.php');

	if ( is_array( $areas ) ) {
		if ( !array_intersect( $areas, array_keys( plgSearchResourcesearchbotAreas() ) )) {
			return array();
		}
	}

	JArrayHelper::toInteger( $areas );

	// load plugin params info
	$plugin =& JPluginHelper::getPlugin('search', 'resourcesearchbot');
	$pluginParams = new JParameter( $plugin->params );



	$limit = $pluginParams->get( 'search_limit', 50 );

	$text = trim( $text );
	if ( $text == '' ) {
		return array();
	}

	switch ( $ordering ) {
		case 'alpha':
			$order = 'a.title ASC';
			break;

		case 'category':
			$order = 'c.name ASC, a.title ASC';
			break;
		case 'popular':
			$order = 'a.hits DESC';
			break;
		case 'newest':
			$order = 'a.ctime DESC';
			break;
		case 'oldest':
			$order = 'a.ctime ASC';
			break;
		default:
			$order = 'a.ctime DESC';
	}

	$where = array();

	if( count( $areas ) ) {
		$where_type = 'AND a.type_id IN ('.implode( ' , ', $areas ).')';
	} else {
		if($pluginParams->get('search_types')) $where_type = 'AND a.type_id IN ('.implode( ' , ', is_array( $pluginParams->get('search_types') ) ? $pluginParams->get('search_types') : array( $pluginParams->get('search_types') ) ).')';
	}
	
	
	// -- Filter articles by expiration/creation dates
	
	$timeWhere = array();
	if ($pluginParams->get('search_future'))
		$timeWhere [] = '(NOW() < a.ctime)';
		
	// show current articles too :)
	$timeWhere [] = '(a.ctime < NOW() AND (NOW() < a.extime OR a.extime = "0000-00-00 00:00:00"))';

	if ($pluginParams->get('search_expired'))
		$timeWhere [] = '(a.extime < NOW() AND a.extime <> "0000-00-00 00:00:00")';
	
	// If all 3 modes (future, current, expired) are enabled, clear the filter
	if (count($timeWhere) == 3)
		$timeWhere = '';
	else
		$timeWhere = ' AND (' .implode(' OR ', $timeWhere) .') ';
	
	$isJoomfishEnabled = JComponentHelper::isEnabled('com_joomfish', true);		

	switch ($phrase) {
		case 'exact':
			//$where[] = 'c.description like "%'.$text.'%"';
			//$where[] = 's.description like "%'.$text.'%"';
			//$where[] = 'tag.tag like "%'.$text.'%"';
			$where[] = 'a.title like "%'.$text.'%"';
			$w[] = 'rv.field_value like "%'.$text.'%"';
			$w[] = 'f.searchable = 1';
			
			$where[] = '('.implode( ' AND ', $w ).')';

			$where = ' WHERE ('.implode( ' OR ', $where ).') '.$where_type.' AND f.published AND a.published = 1 AND c.published = 1  '.$timeWhere;
			break;

		case 'all':
		case 'any':
		default:
			$words = explode( ' ', $text );
			$wheres = array();
			foreach ($words as $key => $word) {
				if( !trim($word) ) continue;

				//$where[$key][] = 'c.description like "%'.$text.'%"';
				//$where[$key][] = 's.description like "%'.$text.'%"';
				//$where[$key][] = 'tag.tag like "%'.$word.'%"';
				$where[$key][] = 'a.title like "%'.$word.'%"';
				if($isJoomfishEnabled){
					$where[$key][] = 'LOWER(jfc.value) LIKE "%'.$word.'%"';
				}
				$w[$key][] = 'rv.field_value like "%'.$word.'%"';
				$w[$key][] = 'f.searchable = 1';
					
				$where[$key][] = '('.implode( ' AND ', $w[$key] ).')';
					
				$wheres[] = '('.implode( ' OR ', $where[$key] ).') '.$where_type.' AND f.published AND a.published = 1 AND c.published = 1';
			}
			$where = 'WHERE (' . implode(') AND (', $wheres ) . ') '.$timeWhere;
			break;
	}

	if(!$isJoomfishEnabled){
		$query  = '  SELECT a.client, a.client_id, a.id, a.type_id, a.user_id, a.title, rc.catid, "*" AS text, a.ctime AS created, "2" AS browsernav,
		IF( s.name != "", CONCAT("'.JText::_( 'Type' ).': ", t.name, " | " , " '.JText::_( 'Section' ).': ", s.name, " | " , " '.JText::_( 'Category' ).': ", GROUP_CONCAT( DISTINCT  c.name SEPARATOR ", ") ),
	        CONCAT("'.JText::_( 'Type' ).': ", t.name, " | " , " '.JText::_( 'Section' ).': ", GROUP_CONCAT( DISTINCT  c.name SEPARATOR ", ") ) ) AS section';
	}else{
		$query  = '  SELECT t.id AS tid, c.id AS rcid, a.client, a.client_id, a.id, a.type_id, a.user_id, a.title, GROUP_CONCAT(DISTINCT c.id ORDER BY c.name) AS catid, "*" AS text, a.ctime AS created, "2" AS browsernav,
		 t.name AS typename , c.name AS rcname, GROUP_CONCAT( DISTINCT  c.name ORDER BY c.name SEPARATOR ":#:") AS category';	
	}
        $query .= "\n      FROM #__js_res_record           AS a"
        ."\n LEFT JOIN #__js_res_types            AS t    ON t.id = a.type_id"
        ."\n LEFT JOIN #__js_res_record_category  AS rc   ON rc.record_id = a.id";
        if($isJoomfishEnabled){
        	$query .= "\n LEFT JOIN #__js_res_category         AS c    ON c.id = rc.catid AND c.id != c.section_id";
        }else{
        	$query .= "\n LEFT JOIN #__js_res_category         AS c    ON c.id = rc.catid"
        	."\n LEFT JOIN #__js_res_category         AS s    ON s.id = c.section_id";
        }
        $query .= "\n LEFT JOIN #__js_res_record_values    AS rv   ON rv.record_id = a.id"
        ."\n LEFT JOIN #__js_res_fields           AS f    ON f.id = rv.field_id";
        if($isJoomfishEnabled){
        	$query .= "\n LEFT JOIN #__jf_content as jfc ON jfc.reference_id = a.id OR jfc.reference_id = rv.id";
        }
        //."\n LEFT JOIN #__js_res_tags_history     AS tagh ON a.id = tagh.record_id"
        //."\n LEFT JOIN #__js_res_tags             AS tag  ON tagh.tag_id = tag.id"
        $query .= "\n ". $where
        ."\n  GROUP BY a.id"
        ."\n  ORDER BY ". $order
        ;

        $db->setQuery( $query, 0, $limit );
        $rows = $db->loadObjectList();
        if($isJoomfishEnabled){
	        foreach ($rows as $key => $r) {
	        	$row = &$rows[$key];
	       		$catids = explode(',', $row->catid);
	       		$categories = explode(':#:', $row->category);
	        	foreach ($catids as $key => $catid) {
	        		$sec = ResHelper::getCategorySection($catid);
	        		if($sec == $catid){
	        			unset($categories[$key]);
	        		}
	        	}
	        	$row->catid = $catids[0];
	        	$section = ResHelper::getSection(Reshelper::getArticleSection($row->id));
	        	$row->section = JText::_( 'Type' ).': '.$row->typename." | ".JText::_( 'Section' ).': '.$section->name.( !empty($categories) ? " | ".JText::_( 'Category' ).': '.implode( '; ', $categories) : '' );
	        }
        }
        $count = count( $rows );
        
        JRequest::setVar('article', 0);
        require_once (JPATH_BASE.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');
        require_once (JPATH_BASE.DS.'components'.DS.'com_resource'.DS.'api.php');
        
        for ( $i = 0; $i < $count; $i++ ) {
        	
        	$fields = $list_model->getFields($rows[$i]->id);

        	$rows[$i]->text = '';

        	$dispatcher =& JDispatcher::getInstance();
        	foreach($fields AS $field){
        		if ($field->type == 'taber' || $field->type == 'separator')
        			continue;
        		
//        		$get = false;
        		$field_params = new JParameter($field->params);
//        		JPluginHelper::importPlugin( 'joomsuite_content_fields', $field->type );
//        		$dispatcher->trigger( 'onRenderFieldValue', array (&$get,  &$field, &$rows[$i], $rows[$i]->catid));
        		
//        		$field->record = $item; 
        		$get = false;
				$get = MightyResourcesApi::getFieldValue($field, $rows[$i], $rows[$i]->catid);
        		 
        		if($get)
        		{
        			$field_params->set('tabled', 0);
        			$field->params = $field_params->toString();
        			$field->result = $get;
        			$rows[$i]->text .= $list_model->getFieldValue( $field, $rows[$i]->user_id )." ";
        		}

        	}
        	//$aparams = ResHelper::getTypeParams($rows[$i]->type_id);
        	//$itemid = $aparams->get('item_itemid', $Itemid);
        	$itemid = MEUrl::itemid(null, $rows[$i]->catid, $rows[$i]);// $aparams->get('item_itemid', $Itemid);
        	
        	$link = 'index.php?option=com_resource&controller=article&article='.$rows[$i]->id.'&category_id='.$rows[$i]->catid.'&Itemid='.$itemid;
        	if($rows[$i]->client != 'resource')
        	{
        		$link .= '&client='.urlencode($rows[$i]->client).'&client_id='.$rows[$i]->client_id;
        	}

        	$rows[$i]->href = JRoute::_($link);
        }

        return $rows;
}